diff --git a/src/backend/optimizer/plan/setrefs.c b/src/backend/optimizer/plan/setrefs.c
index baefe0e..6a52c6c 100644
--- a/src/backend/optimizer/plan/setrefs.c
+++ b/src/backend/optimizer/plan/setrefs.c
@@ -148,6 +148,9 @@ static List *set_returning_clause_references(PlannerInfo *root,
 											 Plan *topplan,
 											 Index resultRelation,
 											 int rtoffset);
+static void set_update_tlist_references(PlannerInfo *root,
+										ModifyTable *splan,
+										int rtoffset);
 
 
 /*****************************************************************************
@@ -808,10 +811,14 @@ set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
 		case T_ModifyTable:
 			{
 				ModifyTable *splan = (ModifyTable *) plan;
+				Plan		*subplan = linitial(splan->plans);
 
 				Assert(splan->plan.targetlist == NIL);
 				Assert(splan->plan.qual == NIL);
 
+				if (splan->operation == CMD_UPDATE)
+					set_update_tlist_references(root, splan, rtoffset);
+
 				splan->withCheckOptionLists =
 					fix_scan_list(root, splan->withCheckOptionLists, rtoffset);
 
@@ -819,22 +826,17 @@ set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
 				{
 					List	   *newRL = NIL;
 					ListCell   *lcrl,
-							   *lcrr,
-							   *lcp;
+							   *lcrr;
 
 					/*
-					 * Pass each per-subplan returningList through
+					 * Pass each per-resultrel returningList through
 					 * set_returning_clause_references().
 					 */
 					Assert(list_length(splan->returningLists) == list_length(splan->resultRelations));
-					Assert(list_length(splan->returningLists) == list_length(splan->plans));
-					forthree(lcrl, splan->returningLists,
-							 lcrr, splan->resultRelations,
-							 lcp, splan->plans)
+					forboth(lcrl, splan->returningLists, lcrr, splan->resultRelations)
 					{
 						List	   *rlist = (List *) lfirst(lcrl);
 						Index		resultrel = lfirst_int(lcrr);
-						Plan	   *subplan = (Plan *) lfirst(lcp);
 
 						rlist = set_returning_clause_references(root,
 																rlist,
@@ -2694,6 +2696,52 @@ set_returning_clause_references(PlannerInfo *root,
 	return rlist;
 }
 
+/*
+ * Update splan->updateTargetLists to refer to the subplan's output where
+ * applicable.
+ */
+static void
+set_update_tlist_references(PlannerInfo *root,
+							ModifyTable *splan,
+							int rtoffset)
+{
+	ListCell   *lc1,
+			   *lc2;
+
+	forboth(lc1, splan->resultRelations, lc2, splan->updateTargetLists)
+	{
+		Index	resultRel = lfirst_int(lc1);
+		List   *updateTargetList = lfirst(lc2);
+		ResultRelPlanInfo *resultInfo = root->result_rel_array[resultRel];
+		AttrNumber	resno;
+		ListCell *lc;
+		indexed_tlist *itlist;
+
+		Assert(resultInfo);
+
+		/*
+		 * Make resnos of subplan tlist TLEs match their ordinal position in
+		 * the list.  It's okay to scribble on them now.
+		 */
+		resno = 1;
+		foreach(lc, resultInfo->subplanTargetList)
+		{
+			TargetEntry *tle = lfirst(lc);
+
+			tle->resno = resno++;
+		}
+
+		itlist = build_tlist_index(resultInfo->subplanTargetList);
+		lfirst(lc2) = fix_join_expr(root,
+									updateTargetList,
+									itlist,
+									NULL,
+									resultRel,
+									rtoffset);
+
+	}
+}
+
 
 /*****************************************************************************
  *					QUERY DEPENDENCY MANAGEMENT
diff --git a/src/backend/optimizer/prep/prepjointree.c b/src/backend/optimizer/prep/prepjointree.c
index 1452172..d24ac34 100644
--- a/src/backend/optimizer/prep/prepjointree.c
+++ b/src/backend/optimizer/prep/prepjointree.c
@@ -926,7 +926,6 @@ pull_up_simple_subquery(PlannerInfo *root, Node *jtnode, RangeTblEntry *rte,
 	subroot->grouping_map = NULL;
 	subroot->minmax_aggs = NIL;
 	subroot->qual_security_level = 0;
-	subroot->inhTargetKind = INHKIND_NONE;
 	subroot->hasRecursion = false;
 	subroot->wt_param_id = -1;
 	subroot->non_recursive_path = NULL;
diff --git a/src/backend/optimizer/prep/preptlist.c b/src/backend/optimizer/prep/preptlist.c
index d56d8c6..b92e3ed 100644
--- a/src/backend/optimizer/prep/preptlist.c
+++ b/src/backend/optimizer/prep/preptlist.c
@@ -45,6 +45,7 @@
 #include "catalog/pg_type.h"
 #include "nodes/makefuncs.h"
 #include "optimizer/optimizer.h"
+#include "optimizer/plancat.h"
 #include "optimizer/prep.h"
 #include "optimizer/tlist.h"
 #include "parser/parse_coerce.h"
@@ -111,13 +112,27 @@ preprocess_targetlist(PlannerInfo *root)
 	 * for heap_form_tuple to work, the targetlist must match the exact order
 	 * of the attributes. We also need to fill in any missing attributes. -ay
 	 * 10/94
+	 *
+	 * For UPDATE, we don't expand the plan's targetlist.  Instead, another
+	 * targetlist to be computed separately from the plan's targetlist is
+	 * built and passed to the executor in the ModifyTable node; see
+	 * make_update_targetlist().
 	 */
 	tlist = parse->targetList;
-	if (command_type == CMD_INSERT || command_type == CMD_UPDATE)
+	if (command_type == CMD_INSERT)
 		tlist = expand_targetlist(tlist, command_type,
 								  result_relation, target_relation);
 
 	/*
+	 * Make ResultRelPlanInfo for a UPDATE/DELETE result relation.  If the
+	 * relation has inheritance children, they will get one too when
+	 * query_planner() adds them.
+	 */
+	if (target_relation && command_type != CMD_INSERT)
+		make_result_relation_info(root, result_relation, target_relation,
+								  NULL);
+
+	/*
 	 * Add necessary junk columns for rowmarked rels.  These values are needed
 	 * for locking of rels selected FOR UPDATE/SHARE, and to do EvalPlanQual
 	 * rechecking.  See comments for PlanRowMark in plannodes.h.  If you
@@ -415,6 +430,99 @@ expand_targetlist(List *tlist, int command_type,
 	return new_tlist;
 }
 
+/*
+ * make_update_targetlist
+ *		Makes UPDATE targetlist such that "plan" TLEs are used for the
+ *		attributes for which they are present.  For the rest, Vars are
+ *		added to fetch the existing values in the "old" tuple of the
+ *		attributes that are not dropped, and NULL constants otherwise.
+ */
+List *
+make_update_targetlist(PlannerInfo *root,
+					   Index rti, Relation relation,
+					   List *plan_tlist)
+{
+	List	   *new_tlist = NIL;
+	ListCell   *plan_item;
+	int			attrno,
+				numattrs;
+
+	plan_item = list_head(plan_tlist);
+
+	numattrs = RelationGetNumberOfAttributes(relation);
+	for (attrno = 1; attrno <= numattrs; attrno++)
+	{
+		Form_pg_attribute att = TupleDescAttr(relation->rd_att, attrno - 1);
+		TargetEntry *new_tle = NULL;
+		Node	   *new_expr;
+
+		if (plan_item != NULL)
+		{
+			TargetEntry *plan_tle = (TargetEntry *) lfirst(plan_item);
+
+			if (!plan_tle->resjunk && plan_tle->resno == attrno)
+			{
+				/* Don't use the plan TLE as is; it gets changed later. */
+				new_tle = copyObject(plan_tle);
+				plan_item = lnext(plan_tlist, plan_item);
+			}
+		}
+
+
+		/*
+		 * If not plan TLE present, generate a Var reference to the existing
+		 * value of the attribute, so that it gets copied to the new tuple. But
+		 * generate a NULL for dropped columns (we want to drop any old values).
+		 */
+		if (new_tle == NULL)
+		{
+			if (!att->attisdropped)
+			{
+				new_expr = (Node *) makeVar(rti,
+											attrno,
+											att->atttypid,
+											att->atttypmod,
+											att->attcollation,
+											0);
+			}
+			else
+			{
+				/* Insert NULL for dropped column */
+				new_expr = (Node *) makeConst(INT4OID,
+											  -1,
+											  InvalidOid,
+											  sizeof(int32),
+											  (Datum) 0,
+											  true, /* isnull */
+											  true /* byval */ );
+			}
+			new_tle = makeTargetEntry((Expr *) new_expr,
+									  attrno,
+									  pstrdup(NameStr(att->attname)),
+									  false);
+			new_tlist = lappend(new_tlist, new_tle);
+		}
+		else
+			new_tlist = lappend(new_tlist, new_tle);
+	}
+
+
+	/*
+	 * The remaining tlist entries should be resjunk.  We don't need them
+	 * for the update target list, but still check that they really are
+	 * junk.
+	 */
+	while (plan_item)
+	{
+		TargetEntry *plan_tle = (TargetEntry *) lfirst(plan_item);
+
+		if (!plan_tle->resjunk)
+			elog(ERROR, "targetlist is not sorted correctly");
+		plan_item = lnext(plan_tlist, plan_item);
+	}
+
+	return new_tlist;
+}
 
 /*
  * Locate PlanRowMark for given RT index, or return NULL if none
diff --git a/src/backend/optimizer/util/appendinfo.c b/src/backend/optimizer/util/appendinfo.c
index d722063..c949544 100644
--- a/src/backend/optimizer/util/appendinfo.c
+++ b/src/backend/optimizer/util/appendinfo.c
@@ -18,6 +18,7 @@
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
 #include "optimizer/appendinfo.h"
+#include "optimizer/tlist.h"
 #include "parser/parsetree.h"
 #include "utils/lsyscache.h"
 #include "utils/rel.h"
@@ -29,6 +30,7 @@ typedef struct
 	PlannerInfo *root;
 	int			nappinfos;
 	AppendRelInfo **appinfos;
+	bool		need_parent_wholerow;
 } adjust_appendrel_attrs_context;
 
 static void make_inh_translation_list(Relation oldrelation,
@@ -37,8 +39,6 @@ static void make_inh_translation_list(Relation oldrelation,
 									  AppendRelInfo *appinfo);
 static Node *adjust_appendrel_attrs_mutator(Node *node,
 											adjust_appendrel_attrs_context *context);
-static List *adjust_inherited_tlist(List *tlist,
-									AppendRelInfo *context);
 
 
 /*
@@ -200,42 +200,42 @@ adjust_appendrel_attrs(PlannerInfo *root, Node *node, int nappinfos,
 	context.root = root;
 	context.nappinfos = nappinfos;
 	context.appinfos = appinfos;
+	context.need_parent_wholerow = true;
 
 	/* If there's nothing to adjust, don't call this function. */
 	Assert(nappinfos >= 1 && appinfos != NULL);
 
-	/*
-	 * Must be prepared to start with a Query or a bare expression tree.
-	 */
-	if (node && IsA(node, Query))
-	{
-		Query	   *newnode;
-		int			cnt;
+	/* Should never be translating a Query tree. */
+	Assert (node == NULL || !IsA(node, Query));
+	result = adjust_appendrel_attrs_mutator(node, &context);
 
-		newnode = query_tree_mutator((Query *) node,
-									 adjust_appendrel_attrs_mutator,
-									 (void *) &context,
-									 QTW_IGNORE_RC_SUBQUERIES);
-		for (cnt = 0; cnt < nappinfos; cnt++)
-		{
-			AppendRelInfo *appinfo = appinfos[cnt];
+	return result;
+}
 
-			if (newnode->resultRelation == appinfo->parent_relid)
-			{
-				newnode->resultRelation = appinfo->child_relid;
-				/* Fix tlist resnos too, if it's inherited UPDATE */
-				if (newnode->commandType == CMD_UPDATE)
-					newnode->targetList =
-						adjust_inherited_tlist(newnode->targetList,
-											   appinfo);
-				break;
-			}
-		}
+/*
+ * adjust_target_appendrel_attrs
+ *		like adjust_appendrel_attrs, but treats wholerow Vars a bit
+ *		differently in that it doesn't convert any child table
+ *		wholerows contained in 'node' back to the parent reltype.
+ */
+Node *
+adjust_target_appendrel_attrs(PlannerInfo *root, Node *node,
+							  AppendRelInfo *appinfo)
+{
+	Node	   *result;
+	adjust_appendrel_attrs_context context;
 
-		result = (Node *) newnode;
-	}
-	else
-		result = adjust_appendrel_attrs_mutator(node, &context);
+	context.root = root;
+	context.nappinfos = 1;
+	context.appinfos = &appinfo;
+	context.need_parent_wholerow = false;
+
+	/* If there's nothing to adjust, don't call this function. */
+	Assert(appinfo != NULL);
+
+	/* Should never be translating a Query tree. */
+	Assert (node == NULL || !IsA(node, Query));
+	result = adjust_appendrel_attrs_mutator(node, &context);
 
 	return result;
 }
@@ -277,9 +277,25 @@ adjust_appendrel_attrs_mutator(Node *node,
 			{
 				Node	   *newnode;
 
+				/*
+				 * If this Var appears to have a unusual attno assigned,
+				 * it must be one of the "special" Vars assigned to parent
+				 * target table.
+				 */
 				if (var->varattno > list_length(appinfo->translated_vars))
-					elog(ERROR, "attribute %d of relation \"%s\" does not exist",
-						 var->varattno, get_rel_name(appinfo->parent_reloid));
+				{
+					SpecialJunkVarInfo *sjv =
+						get_special_junk_var(context->root, var->varattno);
+
+					if (sjv == NULL)
+						elog(ERROR, "attribute %d of relation \"%s\" does not exist",
+							 var->varattno, get_rel_name(appinfo->parent_reloid));
+					if (!bms_is_member(appinfo->child_relid, sjv->child_relids))
+						return (Node *) makeNullConst(var->vartype,
+													  var->vartypmod,
+													  var->varcollid);
+					var->varattno = sjv->varattno;
+				}
 				newnode = copyObject(list_nth(appinfo->translated_vars,
 											  var->varattno - 1));
 				if (newnode == NULL)
@@ -298,7 +314,10 @@ adjust_appendrel_attrs_mutator(Node *node,
 				if (OidIsValid(appinfo->child_reltype))
 				{
 					Assert(var->vartype == appinfo->parent_reltype);
-					if (appinfo->parent_reltype != appinfo->child_reltype)
+					/* Make sure the Var node has the right type ID, too */
+					var->vartype = appinfo->child_reltype;
+					if (appinfo->parent_reltype != appinfo->child_reltype &&
+						context->need_parent_wholerow)
 					{
 						ConvertRowtypeExpr *r = makeNode(ConvertRowtypeExpr);
 
@@ -306,8 +325,6 @@ adjust_appendrel_attrs_mutator(Node *node,
 						r->resulttype = appinfo->parent_reltype;
 						r->convertformat = COERCE_IMPLICIT_CAST;
 						r->location = -1;
-						/* Make sure the Var node has the right type ID, too */
-						var->vartype = appinfo->child_reltype;
 						return (Node *) r;
 					}
 				}
@@ -627,16 +644,13 @@ adjust_child_relids_multilevel(PlannerInfo *root, Relids relids,
  * the target resnos match the child table (they may not, in the case of
  * a column that was added after-the-fact by ALTER TABLE).  In some cases
  * this can force us to re-order the tlist to preserve resno ordering.
- * (We do all this work in special cases so that preptlist.c is fast for
- * the typical case.)
  *
- * The given tlist has already been through expression_tree_mutator;
- * therefore the TargetEntry nodes are fresh copies that it's okay to
- * scribble on.
+ * Note that the input tlist is scribbled on, so the caller must have made
+ * a copy of it first.
  *
  * Note that this is not needed for INSERT because INSERT isn't inheritable.
  */
-static List *
+List *
 adjust_inherited_tlist(List *tlist, AppendRelInfo *context)
 {
 	bool		changed_it = false;
@@ -663,9 +677,11 @@ adjust_inherited_tlist(List *tlist, AppendRelInfo *context)
 			elog(ERROR, "attribute %d of relation \"%s\" does not exist",
 				 tle->resno, get_rel_name(context->parent_reloid));
 		childvar = (Var *) list_nth(context->translated_vars, tle->resno - 1);
-		if (childvar == NULL || !IsA(childvar, Var))
-			elog(ERROR, "attribute %d of relation \"%s\" does not exist",
-				 tle->resno, get_rel_name(context->parent_reloid));
+		/* Ignore dummy TLEs for the parent's dropped columns. */
+		Assert(childvar != NULL ||
+			   (IsA(tle->expr, Const) && ((Const *) tle->expr)->constisnull));
+		if (childvar == NULL)
+			continue;
 
 		if (tle->resno != childvar->varattno)
 		{
@@ -695,6 +711,10 @@ adjust_inherited_tlist(List *tlist, AppendRelInfo *context)
 			if (tle->resjunk)
 				continue;		/* ignore junk items */
 
+			/* Also the dummy TLEs for the parent's dropped columns. */
+			if (IsA(tle->expr, Const) && ((Const *) tle->expr)->constisnull)
+				continue;
+
 			if (tle->resno == attrno)
 				new_tlist = lappend(new_tlist, tle);
 			else if (tle->resno > attrno)
diff --git a/src/backend/optimizer/util/inherit.c b/src/backend/optimizer/util/inherit.c
index 3132fd3..a79b77d 100644
--- a/src/backend/optimizer/util/inherit.c
+++ b/src/backend/optimizer/util/inherit.c
@@ -19,8 +19,10 @@
 #include "catalog/partition.h"
 #include "catalog/pg_inherits.h"
 #include "catalog/pg_type.h"
+#include "foreign/fdwapi.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
+#include "nodes/nodeFuncs.h"
 #include "optimizer/appendinfo.h"
 #include "optimizer/inherit.h"
 #include "optimizer/optimizer.h"
@@ -29,16 +31,19 @@
 #include "optimizer/planner.h"
 #include "optimizer/prep.h"
 #include "optimizer/restrictinfo.h"
+#include "optimizer/tlist.h"
 #include "parser/parsetree.h"
 #include "partitioning/partdesc.h"
 #include "partitioning/partprune.h"
+#include "utils/lsyscache.h"
 #include "utils/rel.h"
 
 
 static void expand_partitioned_rtentry(PlannerInfo *root, RelOptInfo *relinfo,
 									   RangeTblEntry *parentrte,
 									   Index parentRTindex, Relation parentrel,
-									   PlanRowMark *top_parentrc, LOCKMODE lockmode);
+									   PlanRowMark *top_parentrc, LOCKMODE lockmode,
+									   RelOptInfo *rootrelinfo);
 static void expand_single_inheritance_child(PlannerInfo *root,
 											RangeTblEntry *parentrte,
 											Index parentRTindex, Relation parentrel,
@@ -49,6 +54,15 @@ static Bitmapset *translate_col_privs(const Bitmapset *parent_privs,
 									  List *translated_vars);
 static void expand_appendrel_subquery(PlannerInfo *root, RelOptInfo *rel,
 									  RangeTblEntry *rte, Index rti);
+static void add_child_junk_vars(PlannerInfo *root, RelOptInfo *childrel,
+					Relation childrelation, RelOptInfo *rootrel);
+static bool need_special_junk_var(PlannerInfo *root,
+					  TargetEntry *tle,
+					  Index child_relid);
+static void add_special_junk_var(PlannerInfo *root,
+					 TargetEntry *tle,
+					 Index child_relid,
+					 RelOptInfo *rootrel);
 
 
 /*
@@ -85,6 +99,8 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 	PlanRowMark *oldrc;
 	bool		old_isParent = false;
 	int			old_allMarkTypes = 0;
+	List	   *newvars = NIL;
+	ListCell   *l;
 
 	Assert(rte->inh);			/* else caller error */
 
@@ -141,7 +157,8 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 		 * extract the partition key columns of all the partitioned tables.
 		 */
 		expand_partitioned_rtentry(root, rel, rte, rti,
-								   oldrelation, oldrc, lockmode);
+								   oldrelation, oldrc, lockmode,
+								   rel);
 	}
 	else
 	{
@@ -151,7 +168,6 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 		 * children, so it's not possible for both cases to apply.)
 		 */
 		List	   *inhOIDs;
-		ListCell   *l;
 
 		/* Scan for all members of inheritance set, acquire needed locks */
 		inhOIDs = find_all_inheritors(parentOID, lockmode, NULL);
@@ -180,6 +196,7 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 			Relation	newrelation;
 			RangeTblEntry *childrte;
 			Index		childRTindex;
+			RelOptInfo *childrel;
 
 			/* Open rel if needed; we already have required locks */
 			if (childOID != parentOID)
@@ -205,7 +222,14 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 											&childrte, &childRTindex);
 
 			/* Create the otherrel RelOptInfo too. */
-			(void) build_simple_rel(root, childRTindex, rel);
+			childrel = build_simple_rel(root, childRTindex, rel);
+
+			if (rti == root->parse->resultRelation)
+			{
+				Assert(root->parse->commandType == CMD_UPDATE ||
+					   root->parse->commandType == CMD_DELETE);
+				add_child_junk_vars(root, childrel, newrelation, rel);
+			}
 
 			/* Close child relations, but keep locks */
 			if (childOID != parentOID)
@@ -226,7 +250,6 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 		Var		   *var;
 		TargetEntry *tle;
 		char		resname[32];
-		List	   *newvars = NIL;
 
 		/* The old PlanRowMark should already have necessitated adding TID */
 		Assert(old_allMarkTypes & ~(1 << ROW_MARK_COPY));
@@ -265,14 +288,56 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 			root->processed_tlist = lappend(root->processed_tlist, tle);
 			newvars = lappend(newvars, var);
 		}
+	}
+
+	/*
+	 * If parent is a result relation, add necessary junk columns to the
+	 * top level targetlist and parent's reltarget.
+	 */
+	if (rti == root->parse->resultRelation)
+	{
+		int		resno = list_length(root->processed_tlist) + 1;
+		TargetEntry *tle;
+		Var	   *var;
 
 		/*
-		 * Add the newly added Vars to parent's reltarget.  We needn't worry
-		 * about the children's reltargets, they'll be made later.
+		 * First, we will need a "tableoid" for the executor to identify
+		 * the result relation to update or delete for a given tuple.
 		 */
-		add_vars_to_targetlist(root, newvars, bms_make_singleton(0), false);
+		var= makeVar(rti, TableOidAttributeNumber, OIDOID, -1, InvalidOid, 0);
+		tle = makeTargetEntry((Expr *) var,
+							  resno,
+							  pstrdup("tableoid"),
+							  true);
+		++resno;
+
+		root->processed_tlist = lappend(root->processed_tlist, tle);
+		newvars = lappend(newvars, var);
+
+		/* Now add "special" child junk Vars. */
+		foreach(l, root->specialJunkVars)
+		{
+			SpecialJunkVarInfo *sjv = lfirst(l);
+			Oid		vartype = sjv->special_attno == 0 ?
+									oldrelation->rd_rel->reltype :
+									sjv->vartype;
+
+			var = makeVar(rti, sjv->special_attno, vartype,
+						  sjv->vartypmod, sjv->varcollid, 0);
+			tle = makeTargetEntry((Expr *) var, resno, sjv->attrname, true);
+			root->processed_tlist = lappend(root->processed_tlist, tle);
+			newvars = lappend(newvars, var);
+			++resno;
+		}
 	}
 
+	/*
+	 * Add the newly added Vars to parent's reltarget.  We needn't worry
+	 * about the children's reltargets, they'll be made later.
+	 */
+	if (newvars != NIL)
+		add_vars_to_targetlist(root, newvars, bms_make_singleton(0), false);
+
 	table_close(oldrelation, NoLock);
 }
 
@@ -284,7 +349,8 @@ static void
 expand_partitioned_rtentry(PlannerInfo *root, RelOptInfo *relinfo,
 						   RangeTblEntry *parentrte,
 						   Index parentRTindex, Relation parentrel,
-						   PlanRowMark *top_parentrc, LOCKMODE lockmode)
+						   PlanRowMark *top_parentrc, LOCKMODE lockmode,
+						   RelOptInfo *rootrelinfo)
 {
 	PartitionDesc partdesc;
 	Bitmapset  *live_parts;
@@ -379,11 +445,19 @@ expand_partitioned_rtentry(PlannerInfo *root, RelOptInfo *relinfo,
 		relinfo->all_partrels = bms_add_members(relinfo->all_partrels,
 												childrelinfo->relids);
 
+		if (rootrelinfo->relid == root->parse->resultRelation)
+		{
+			Assert(root->parse->commandType == CMD_UPDATE ||
+				   root->parse->commandType == CMD_DELETE);
+			add_child_junk_vars(root, childrelinfo, childrel, rootrelinfo);
+		}
+
 		/* If this child is itself partitioned, recurse */
 		if (childrel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
 			expand_partitioned_rtentry(root, childrelinfo,
 									   childrte, childRTindex,
-									   childrel, top_parentrc, lockmode);
+									   childrel, top_parentrc, lockmode,
+									   rootrelinfo);
 
 		/* Close child relation, but keep locks */
 		table_close(childrel, NoLock);
@@ -391,6 +465,212 @@ expand_partitioned_rtentry(PlannerInfo *root, RelOptInfo *relinfo,
 }
 
 /*
+ * add_child_junk_vars
+ *		Check if the row-identifying junk column(s) required by this child
+ *		table is present in the top-level targetlist and if not, add.  The
+ *		junk column's properties (name, type, or Var attribute number) may
+ *		require us to add "special" junk Vars to parent's targetlist which it
+ *		or any of its other children may not be able to produce themselves.
+ *
+ * Note: this only concerns foreign child tables
+ */
+static void
+add_child_junk_vars(PlannerInfo *root, RelOptInfo *childrel,
+					Relation childrelation,
+					RelOptInfo *rootrel)
+{
+	RangeTblEntry *childrte = root->simple_rte_array[childrel->relid];
+	Query	parsetree;
+	List   *child_junk_vars;
+	ListCell *lc;
+
+	/* Currently, only foreign children may require such junk columns. */
+	if (childrel->fdwroutine == NULL ||
+		childrel->fdwroutine->AddForeignUpdateTargets == NULL)
+		return;
+
+	/*
+	 * Ask the table's FDW what junk Vars it needs.
+	 */
+	memcpy(&parsetree, root->parse, sizeof(Query));
+	parsetree.resultRelation = childrel->relid;
+	parsetree.targetList = NIL;
+	childrel->fdwroutine->AddForeignUpdateTargets(&parsetree,
+												  childrte,
+												  childrelation);
+	child_junk_vars = parsetree.targetList;
+
+	/*
+	 * We need the "old" tuple to fill up the values for unassigned-to
+	 * attributes in the case of UPDATE.  We will need it also if there
+	 * are any DELETE row triggers.  This matches what
+	 * rewriteTargetListUD() does.
+	 */
+	if (parsetree.commandType == CMD_UPDATE ||
+		(childrelation->trigdesc &&
+		 (childrelation->trigdesc->trig_delete_after_row ||
+		  childrelation->trigdesc->trig_delete_before_row)))
+	{
+		Var *var;
+		TargetEntry *tle;
+
+		var = makeWholeRowVar(childrte,
+							  parsetree.resultRelation,
+							  0,
+							  false);
+
+		tle = makeTargetEntry((Expr *) var,
+							  list_length(child_junk_vars) + 1,
+							  "wholerow",
+							  true);
+		child_junk_vars = lappend(child_junk_vars, tle);
+	}
+
+	/* Check if any of the child junk Vars need any special attention. */
+	foreach(lc, child_junk_vars)
+	{
+		TargetEntry *tle = lfirst(lc);
+
+		Assert(tle->resjunk);
+
+		if (!IsA(tle->expr, Var))
+			elog(ERROR, "UPDATE junk expression added by foreign table %u not suppported",
+				 childrte->relid);
+
+		if (need_special_junk_var(root, tle, childrel->relid))
+			add_special_junk_var(root, tle, childrel->relid, rootrel);
+	}
+}
+
+/*
+ * Check if we need to consider the junk TLE required by the given child
+ * target relation a "special" junk var, so as to create a new
+ * SpecialJunkVarInfo for it.
+ *
+ * Side-effect warning: If the TLE is found to match the properties of some
+ * SpecialJunkVarInfo already present in root->specialJunkVars, this adds
+ * child_relid into SpecialJunkVarInfo.child_relids.
+ */
+static bool
+need_special_junk_var(PlannerInfo *root,
+					  TargetEntry *tle,
+					  Index child_relid)
+{
+	Var   *var = (Var *) tle->expr;
+	ListCell *lc;
+
+	Assert(IsA(var, Var));
+
+	/* Maybe a similar looking TLE was already considered one? */
+	foreach(lc, root->specialJunkVars)
+	{
+		SpecialJunkVarInfo *sjv = lfirst(lc);
+
+		if (strcmp(tle->resname, sjv->attrname) == 0 &&
+			var->vartype == sjv->vartype &&
+			var->varattno == sjv->varattno)
+		{
+			sjv->child_relids = bms_add_member(sjv->child_relids, child_relid);
+			return false;
+		}
+	}
+
+	/* It's special if the top-level targetlist doesn't have it. */
+	foreach(lc, root->parse->targetList)
+	{
+		TargetEntry *known_tle = lfirst(lc);
+		Var	   *known_var = (Var *) known_tle->expr;
+		Oid		known_vartype = exprType((Node *) known_var);
+		AttrNumber	known_varattno = known_var->varattno;
+
+		/* Ignore non-junk columns. */
+		if (!known_tle->resjunk)
+			continue;
+
+		/* Ignore RETURNING expressions too, if any. */
+		if (known_tle->resname == NULL)
+			continue;
+
+		Assert(IsA(known_var, Var));
+		if (strcmp(tle->resname, known_tle->resname) == 0 &&
+			var->vartype == known_vartype &&
+			var->varattno == known_varattno)
+			return false;
+	}
+
+	return true;
+}
+
+/*
+ * Makes a SpecialJunkVarInfo for a child junk Var that was unlike
+ * any other seen so far.
+ */
+static void
+add_special_junk_var(PlannerInfo *root,
+					 TargetEntry *tle,
+					 Index child_relid,
+					 RelOptInfo *rootrel)
+{
+	SpecialJunkVarInfo *sjv;
+	Var	   *var = (Var *) tle->expr;
+	Oid		vartype = exprType((Node *) var);
+	AttrNumber		special_attno;
+	AppendRelInfo  *appinfo = root->append_rel_array[child_relid];
+
+	Assert(IsA(var, Var));
+
+	/*
+	 * If root parent can emit this var, no need to assign "special" attribute
+	 * numbers.  Unfortunately, this results in all the children needlessly
+	 * emitting the column, even if only this child needs it.
+	 */
+	Assert(appinfo != NULL && var->varattno < appinfo->num_child_cols);
+
+	/* Wholerow ok. */
+	if (var->varattno == 0)
+		special_attno = 0;
+	/* A column that is also present in the parent. */
+	else if (appinfo->parent_colnos[var->varattno] > 0)
+		special_attno = appinfo->parent_colnos[var->varattno];
+	/* Nope, use a "special" attribute number. */
+	else
+		special_attno = ++(rootrel->max_attr);
+
+	sjv = makeNode(SpecialJunkVarInfo);
+	sjv->attrname = pstrdup(tle->resname);
+	sjv->vartype = vartype;
+	sjv->vartypmod = exprTypmod((Node *) var);
+	sjv->varcollid = exprCollation((Node *) var);
+	/*
+	 * Parent Var with a "special" attribute number is mapped to a child Var
+	 * with this attribute number, provided the child's RT index is in
+	 * child_relids.  For other children, it's mapped to a NULL constant.
+	 * See adjust_appendrel_attrs_mutator().
+	 */
+	sjv->varattno = var->varattno;
+	sjv->special_attno = special_attno;
+	sjv->child_relids = bms_add_member(NULL, child_relid);
+
+	root->specialJunkVars = lappend(root->specialJunkVars, sjv);
+}
+
+SpecialJunkVarInfo *
+get_special_junk_var(PlannerInfo *root, Index special_attno)
+{
+	ListCell *l;
+
+	foreach(l, root->specialJunkVars)
+	{
+		SpecialJunkVarInfo *sjv = lfirst(l);
+
+		if (sjv->special_attno == special_attno)
+			return sjv;
+	}
+
+	return NULL;
+}
+
+/*
  * expand_single_inheritance_child
  *		Build a RangeTblEntry and an AppendRelInfo, plus maybe a PlanRowMark.
  *
diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index e845a4b..3f977ba 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -3490,6 +3490,7 @@ create_lockrows_path(PlannerInfo *root, RelOptInfo *rel,
  * 'resultRelations' is an integer list of actual RT indexes of target rel(s)
  * 'subpaths' is a list of Path(s) producing source data (one per rel)
  * 'subroots' is a list of PlannerInfo structs (one per rel)
+ * 'updateTargetLists' is a list of UPDATE NEW tuple targetlists.
  * 'withCheckOptionLists' is a list of WCO lists (one per rel)
  * 'returningLists' is a list of RETURNING tlists (one per rel)
  * 'rowMarks' is a list of PlanRowMarks (non-locking only)
@@ -3502,7 +3503,7 @@ create_modifytable_path(PlannerInfo *root, RelOptInfo *rel,
 						Index nominalRelation, Index rootRelation,
 						bool partColsUpdated,
 						List *resultRelations, List *subpaths,
-						List *subroots,
+						List *subroots, List *updateTargetLists,
 						List *withCheckOptionLists, List *returningLists,
 						List *rowMarks, OnConflictExpr *onconflict,
 						int epqParam)
@@ -3511,8 +3512,6 @@ create_modifytable_path(PlannerInfo *root, RelOptInfo *rel,
 	double		total_size;
 	ListCell   *lc;
 
-	Assert(list_length(resultRelations) == list_length(subpaths));
-	Assert(list_length(resultRelations) == list_length(subroots));
 	Assert(withCheckOptionLists == NIL ||
 		   list_length(resultRelations) == list_length(withCheckOptionLists));
 	Assert(returningLists == NIL ||
@@ -3572,6 +3571,7 @@ create_modifytable_path(PlannerInfo *root, RelOptInfo *rel,
 	pathnode->resultRelations = resultRelations;
 	pathnode->subpaths = subpaths;
 	pathnode->subroots = subroots;
+	pathnode->updateTargetLists = updateTargetLists;
 	pathnode->withCheckOptionLists = withCheckOptionLists;
 	pathnode->returningLists = returningLists;
 	pathnode->rowMarks = rowMarks;
